// element.cpp
// Revision 23-may-2006

#include "element.h"

#include "var.h"
#include "trace.h"

ForElementNumber::ForElementNumber (const std::string & nvar,
		BlNumber * addr,
		ProgramPos pos,
		//BlNumber initial,
		BlNumber nmax, BlNumber nstep) :
	ForElement (nvar, pos),
	varaddr (addr),
	max (nmax),
	step (nstep)
{
	//varaddr= addrvarnumber (nvar);
	//* varaddr= initial;
}

ForElementNumberInc::ForElementNumberInc (const std::string & var,
		BlNumber * addr,
		ProgramPos pos,
		//BlNumber initial,
		BlNumber max, BlNumber step) :
	ForElementNumber (var, addr, pos, /*initial, */max, step)
{
	//TRACEFUNC (tr, "ForElementNumberInc::ForElementNumberInc");
}

bool ForElementNumberInc::next ()
{
	* varaddr+= step;
	return * varaddr <= max;
}

ForElementNumberDec::ForElementNumberDec (const std::string & var,
		BlNumber * addr,
		ProgramPos pos,
		//BlNumber initial,
		BlNumber max, BlNumber step) :
	ForElementNumber (var, addr, pos, /*initial,*/ max, step)
{
	//TRACEFUNC (tr, "ForElementNumberDec::ForElementNumberDec");
}

bool ForElementNumberDec::next ()
{
	* varaddr+= step;
	return * varaddr >= max;
}

ForElementInteger::ForElementInteger (const std::string & nvar,
		BlInteger * addr,
		ProgramPos pos,
		//BlInteger initial,
		BlInteger nmax, BlInteger nstep) :
	ForElement (nvar, pos),
	max (nmax),
	step (nstep)
{
	//varaddr= addrvarinteger (nvar);
	varaddr= addr;
	//* varaddr= initial;
}

ForElementIntegerInc::ForElementIntegerInc (const std::string & var,
		BlInteger * addr,
		ProgramPos pos,
		//BlInteger initial,
		BlInteger max, BlInteger step) :
	ForElementInteger (var, addr, pos, /*initial,*/ max, step)
{
	//TRACEFUNC (tr, "ForElementIntegerInc::ForElementIntegerInc");
}

bool ForElementIntegerInc::next ()
{
	* varaddr+= step;
	return * varaddr <= max;
}

ForElementIntegerDec::ForElementIntegerDec (const std::string & var,
		BlInteger * addr,
		ProgramPos pos,
		//BlInteger initial,
		BlInteger max, BlInteger step) :
	ForElementInteger (var, addr, pos, /*initial,*/ max, step)
{
	//TRACEFUNC (tr, "ForElementIntegerDec::ForElementIntegerDec");
}

bool ForElementIntegerDec::next ()
{
	* varaddr+= step;
	return * varaddr >= max;
}

// End of element.cpp
